import { select, json, geoPath, geoMercator, zoom } from 'd3';
import { feature } from 'topojson';

const svg = select('svg')

const netherlandsG = svg.append('g')

const projection = geoMercator().scale(6000).center([5.116667,52.17000])
const pathGenerator = geoPath().projection(projection);

const width = 275;
const height = 610;

const zoomSettings = {
 duration: 1000,
  ease: d3.easeCubicOut,
  zoomLevel: 5
}

var g = svg.append('g');


json('https://cartomap.github.io/nl/wgs84/gemeente_2020.topojson')
	.then(data => {
  	const dataset = feature(data, data.objects.gemeente_2020)
  
  const gemeente = netherlandsG.selectAll('path')
  	.data(dataset.features)
		gemeente.enter()
      .append('path')
  			.attr('d', d => pathGenerator(d))
        .attr("cursor", "pointer")
  			.on("click", clicked)
  		.append('title')
  		.text(d => d.properties.statnaam)

  zoomChart(gemeente, netherlandsG, svg);
  svg.on("click", reset(gemeente));
  
});

function getVariables() {

}



function reset(town) {
  var d3zoom = d3.behavior.zoom()
  .scaleExtent([1, 10])
  .on("zoom", zoomed);
  
    town.transition().style("fill", null);
    svg.transition().duration(750).call(
      zoom.transform,
      d3.zoomIdentity,
      d3.zoomTransform(svg.node()).invert([1960, 800])
    );
}

// later
function clicked(d) {
  const gemeente = d.properties.statnaam
  console.log(d.geometry.coordinates)
  console.log(gemeente)
    const [[x0, y0], [x1, y1]] = d3.geoPath().bounds(d);
    if (event.stopPropagation) event.stopPropagation();
    svg.transition().style("fill", null);
    d3.select(this).transition().style("fill", "red");
    svg.transition().duration(750).call(
      zoom.transform,
      d3.zoomIdentity
        .translate(width / 2, height / 2)
        .scale(Math.min(8, 0.9 / Math.max((x1 - x0) / width, (y1 - y0) / height)))
        .translate(-(x0 + x1) / 2, -(y0 + y1) / 2),
      d3.mouse(event.target, svg.node())
    );
}





  function zoomed(event) {
    const {transform} = event;
    g.attr("transform", transform);
    g.attr("stroke-width", 1 / transform.k);
  }

